<script>
import { socketStore } from '@/plugins/socket.js';
import { onDestroy } from 'svelte';
import { topics } from '@/plugins/store.js';

let derniers = [];
let unsubscribe;
$: {
    if (!unsubscribe) {
        socketStore.update((store) => {
            unsubscribe = store.subscribe(async message => {
                // Do something with the message here
                try {
                    let m = JSON.parse(message)
                    if (m.msg_type == "init") {
                        let messages = m.data
                        for (let i = 0; i < messages.length; i++) {
                            let msg = messages[i]
                            if (msg.topic == "/dons/top") {
                                for (let i = 0; i < msg.message.length; i++) {
                                    msg.message[i].n = i + 1
                                }
                                derniers = msg.message
                            }
                        }
                    } else {
                        let message = m.data.message
                        if (m.data.topic == "/dons/top") {
                            // Compare message.derniers with derniers to see if there's new people, if so, add them one by one
                            for (let i = 0; i < message.length; i++) {
                                // is in derniers
                                message[i].n = i + 1    
                            }
                            derniers = message
                        }
                    }
                } catch (e) {
                    console.log(e)
                }
            });
            return store;
        });
    }
}

// Add a topic to the socket
topics.update(store => {
    store.push("/dons/top");
    return store;
});

socketStore.update(store => {
    store.send(JSON.stringify({"topics": $topics}));
    return store;
});

onDestroy(() => {
    unsubscribe();
    // Remove the topic from the socket
    topics.update(store => {
        store.splice(store.indexOf("/dons/top"), 1);
        return store;
    });
    socketStore.update(store => {
        store.send(JSON.stringify({"topics": $topics}));
        return store;
    });
});
</script>

<style>
    @import url('https://fonts.cdnfonts.com/css/edo'); 
    .color {
        /* beautiful gradient with light pinkish color */ 
        background: rgb(255,156,237);
        background: linear-gradient(to bottom right, rgba(124,222,255,1) 0%, rgba(255,156,237,1) 33%, rgb(181, 255, 190) 88%, rgb(237, 240, 83) 100%); 
    } 
    .person {
        /* Widget with boxes */
        color: #fff;
        text-shadow: 0 0 10px #3333;
        background-color: #bbb5 ;
        border: 1px solid #555;
        border-radius: 5px; 
        margin-top:10px;
        padding: 15px;
        font-size: 30px;
        font-weight: 800;
    }
    .slide-in-left{-webkit-animation:slide-in-left .5s cubic-bezier(.25,.46,.45,.94) both;animation:slide-in-left .5s cubic-bezier(.25,.46,.45,.94) both}
    .slide-out-right{-webkit-animation:slide-out-right .5s cubic-bezier(.55,.085,.68,.53) both;animation:slide-out-right .5s cubic-bezier(.55,.085,.68,.53) both}
    @keyframes slide-out-right{0%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}100%{-webkit-transform:translateX(1000px);transform:translateX(1000px);opacity:0}}@keyframes slide-out-right{0%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}100%{-webkit-transform:translateX(1000px);transform:translateX(1000px);opacity:0}}
    @keyframes slide-in-left{0%{-webkit-transform:translateX(-1000px);transform:translateX(-1000px);opacity:0}100%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}}@keyframes slide-in-left{0%{-webkit-transform:translateX(-1000px);transform:translateX(-1000px);opacity:0}100%{-webkit-transform:translateX(0);transform:translateX(0);opacity:1}}
</style>
    


<div class="color flex flex-col w-screen h-screen items-center justify-center absolute top-0 -z-10">
    <div class="self-center">
        <div class="flex flex-col items-center text-7xl font-extrabold -mt-20">
            <span class="mb-10 text-white">
                Top donateurs:
            </span>
            <div class="text-xl font-extrabold" style="background-color:transparent">
                {#each derniers as don}
                    {#if don.name != undefined}
                        <p class="person">
                            {don.n} - {don.name} a donné {don.total/100}€
                        </p>
                    {/if}
                {/each}
            </div>
            
        </div>
    </div>  
</div>